<?php
/*---------------------------------------------------------------
# Package - Stools Framework  
# ---------------------------------------------------------------
# Author - mixwebtemplates http://www.mixwebtemplates.com
# Copyright (C) 2008 - 2020 mixwebtemplates.com. All Rights Reserved. 
# Websites: http://www.mixwebtemplates.com
-----------------------------------------------------------------*/
//no direct accees
defined ('_JEXEC') or die ('resticted aceess');

class SboostMenu {
	var $_params 	= null;
	var $_menu	 	= null;
	var $children	= null;
	var $open 		= null;
	var $items 		= null;
	var $Itemid 	= 0;
	
	function __construct( &$params,$_menu){
		global $Itemid;
		$this->_params = $params;
		$this->_menu = $_menu;//menu type, eg. moo
		$this->Itemid  = $Itemid;
		$this->loadMenu();
	}
	
	function  loadMenu(){
		
		$user = JFactory::getUser();
		$children = array ();
		
		// Get Menu Items
		$app = JFactory::getApplication();
		$items = $app->getMenu();
		
		$active = ($items->getActive()) ? $items->getActive() : $items->getDefault();
		$this->open		= isset($active) ? array_reverse($active->tree) : array();
			
		$rows = $items->getItems('menutype', $this->getParam('menutype', 'mainmenu'));
		
		if(!count($rows)) 
			$rows = $items->getItems('menutype', 'mainmenu');
		if(!count($rows)) return;
		
		// first pass - collect children
		$cacheIndex = array();
		$this->items = array();
		foreach ($rows as $index => $v) {
		   	//1.6 compatible
   	    	if (isset ($v->title)) $v->name = $v->title; 
   	    	if (isset ($v->parent_id)) $v->parent = $v->parent_id;
			
			$v->name = stripslashes(htmlspecialchars($v->name));// replace & with amp; for xhtml compliance
			
			if (in_array($v->access, $user->getAuthorisedViewLevels())) {
				$pt = $v->parent;
				$list = @ $children[$pt] ? $children[$pt] : array ();

				
				array_push($list, $v);
				$children[$pt] = $list;
				$cacheIndex[$v->id] = $index;
				$this->items[$v->id] = $v;
			}
		}
		
		$this->children = $children;
	}
	
	//Generate menu item
	function genMenuItem($item, $level = 0, $pos = '')
	{
		$data = '';
		$title = '';
		$menu_title = '';
		
		// Print a link if it exists
		$active = $this->genClass ($item, $level, $pos);
		$iParams = new JObject(json_decode($item->params));
		
		if ($iParams->get('showmenutitle',1)) {
			$menu_title .= $item->name;		
		} else {
			$menu_title .= '<span class="menu-title">&nbsp;</span>';		
		}	
		
		if ($iParams->get('desc')) {
			$menu_title .= '<span class="menu-desc">'. $iParams->get('desc').'</span>';
		}		
		
		//Menu image
		if ($this->getParam('show_menu_image') && $iParams->get('menu_image') && $iParams->get('menu_image') != -1) {
			if ($this->getParam('menu_image_position',0)=='1') { 
				$txt = '<img class="menu-image" src="'.JURI::base().$iParams->get('menu_image').'" alt=" " />' . $menu_title . '';
			} else {
				$txt = '<span class="has-image" style="background-image:url('.JURI::base().$iParams->get('menu_image').')">' . $menu_title . '</span>';			
			}
		} else {
			$txt =  $menu_title ;
		}
				
		if ($item->type == 'menulink')
		{
			$app = JFactory::getApplication();
			$menu = $app->getMenu(); 
			$alias_item = clone($menu->getItem($item->query['Itemid']));
			if (!$alias_item) {
				return false;
			} else {
				$item->url = $alias_item->link;
			}
		}
		
		//Handle Links

		switch ($item->type)
		{
			case 'separator' :
				$item->url = '#';
				break;
				
			case 'url' :
				if ((strpos($item->link, 'index.php?') !== false) && (strpos($item->link, 'Itemid=') === false)) {
					$item->url = $item->link.'&amp;Itemid='.$item->id;
				} else {
					$item->url = $item->link;
				}
				break;
				
			case 'alias':
				$item->url = 'index.php?Itemid='.$item->params->get('aliasoptions');
				break;
				
			default :
				$app = JFactory::getApplication();
				$menu = $app->getMenu(); 
				$item->url = $item->link.'&amp;Itemid='.$item->id;
				break;

		}			
		
		if ($item->name) {
			if ($item->type == 'separator')
			{
				$data = '<a href="#" '.$active.'>'.$txt.'</a>';				
			} else {
				if ($item->url != null)
				{
					// Handle SSL links
					
					$iParams =new JObject(json_decode($item->params));
					
					$iSecure = $iParams->def('secure', 0);
					if ($item->home == 1) {
						$item->url = JURI::base();
					} elseif (strcasecmp(substr($item->url, 0, 4), 'http') && (strpos($item->link, 'index.php?') !== false)) {
						$item->url = JRoute::_($item->url, true, $iSecure);
					} else {
						$item->url = str_replace('&', '&amp;', $item->url);
					}
					
					switch ($item->browserNav)
					{
						default:
						case 0:
							// _top
							 if (!empty($this->children[$item->id]))
        {
							$data = '<a class="nav-link" href="'.$item->url.'" '.$active.' '.$title.'>'.$txt.' <span class="caret"></span></a>';} else {
							$data = '<a class="nav-link" href="'.$item->url.'" '.$active.' '.$title.'>'.$txt.'</a>';} 
							break;
						case 1:
							// _blank
							$data = '<a class="nav-link" href="'.$item->url.'" target="_blank" '.$active.' '.$title.'>'.$txt.'</a>';
							break;
						case 2:
							// window.open
							$attribs = 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,'.$this->getParam('window_open');
	  
							// hrm...this is a bit dickey
							$link = str_replace('index.php', 'index2.php', $item->url);
							$data = '<a  class="nav-link href="'.$link.'" onclick="window.open(this.href,\'targetWindow\',\''.$attribs.'\');return false;" '.$active.' '.$title.'>'.$txt.'</a>';
							break;
					}
				} else {
					$data = '<a  class="nav-link '.$active.' '.$title.'>'.$txt.'</a>';
				}
			}
		}
		

		//End Megamenu
		echo $data;				
	}
	
	//Load subcontent
	function loadSubContent($item=null,$subItem=null,$level=0,$ret=true) {}
	
	/*Menu Item Styling area started*/
	
	function beginUl($pid=0, $level=0, $ret = false){
		$data='';
		if ($level) {
{
				$data .= '<ul class="navbar-nav">';
			}
		if ($ret) return $data; else echo $data;
		}
	}
	
	function endUl($pid=0, $level=0, $ret = false){
		$data='';
		if ($level) {
{
				$data .= '</ul>';
			}
		if ($ret) return $data; else echo $data;
		}	
	}

	function beginLi($mitem=null, $level = 0, $pos = ''){
		$active = $this->genClass ($mitem, $level, $pos);
		echo "<li $active>";
		
	}
	
	function endLi($mitem=null, $level = 0, $pos = ''){
		
		echo "</li>";
	}

	
	function genClass ($mitem, $level, $pos) {
		$iParams = new JObject(json_decode($mitem->params));
		$active = in_array($mitem->id, $this->open);
		$cls = '';
		 if (!empty($this->children[$mitem->id]))
        {
           $cls .= "nav-item dropdown fadeup".($active?" active":"");
        } else {
		$cls .= "nav-item".($active?" active":"");}
		return $cls?"class=\"$cls\"":"";			
	}
	
	/*End menu items styling*/
	
	function hasSubMenu($level) {
		$pid = $this->getParentId ($level);
		if (!$pid) return false;
		return $this->hasSubItems ($pid);
	}
	
	function hasSubItems($id){
		if (@$this->children[$id]) return true;
		return false;
	}	
	
	function hasSub () {
		$pid = $this->getParentId (1);
		if (!$pid) return false;
		return $this->hasSubItems ($pid);
	}
	
	function genMenu($startlevel=0, $endlevel = -1){

		$this->setParam('startlevel', $startlevel);
		$this->setParam('endlevel', $endlevel==-1?20:$endlevel);
		
		if ($this->getParam('startlevel') == 0) {
			//for first level
			$this->genMenuItems (1, 0);
		}else{
			//for sub level
			$pid = $this->getParentId($this->getParam('startlevel'));
			if ($pid)
			$this->genMenuItems ($pid, $this->getParam('startlevel'));
		}	
	}
	
	function showMenu($startlevel=0, $endlevel = 20){
	$this->genMenu(0);}
	
	function genMenuItems($pid, $level) {
		if (@$this->children[$pid]) {
			$j = 0;
			$cols = $pid && $this->_menu=='mega' && isset($this->items[$pid]) && isset($this->items[$pid]->cols) && $this->items[$pid]->cols ? $this->items[$pid]->cols : 1;				
			$total = count ($this->children[$pid]);
			$tmp = $pid && isset($this->items[$pid])?$this->items[$pid]:new stdclass();
			if ($cols > 1) {
				$fixitems = count($tmp->col);
				if ($fixitems < $cols) {
					$fixitem = array_sum($tmp->col);
					$leftitem = $total-$fixitem;
					$items = ceil ($leftitem/($cols-$fixitems));
					for ($m=0;$m<$cols && $leftitem > 0;$m++) {
						if (!isset($tmp->col[$m]) || !$tmp->col[$m]) { 
							if ($leftitem > $items) {
								$tmp->col[$m] = $items;
								$leftitem -= $items;
							} else {
								$tmp->col[$m] = $leftitem;
								$leftitem = 0;
							}
						}
					}
					
					$cols = count ($tmp->col);
					$tmp->cols = $cols;
				}
			} else {
				$tmp->col = array($total);
			}
			
			$this->beginUl($pid, $level);
			
			for ($col=0;$col<$cols && $j<$total;$col++) {
				$pos = ($col == 0 ) ? 'first' : (($col == $cols-1) ? 'last' :'');
				
				$i = 0;
				while ($i < $tmp->col[$col] && $j<$total) {
					$row = $this->children[$pid][$j];
					$pos = ($i == 0 ) ? 'first' : (($i == count($this->children[$pid])-1) ? 'last' :'');
					$iParams = new JObject(json_decode($row->params));
					
					$this->beginLi($row, $level, $pos);
					$this->genMenuItem( $row, $level, $pos);

					if ($this->_menu=='mega' && $row->megaparams->get('group')) $this->genMenuItems( $row->id, $level ); //Do not increase level if group
						elseif ($level < $this->getParam('endlevel')) $this->genMenuItems( $row->id, $level+1 );

					$this->endLi($row, $level, $pos);
					$j++;$i++;
				}
			}
			$this->endUl($pid, $level);
		}
	}
	
	//get parameter
	function getParam($paramName, $default=null){
		return $this->_params->get($paramName, $default);
	}
	
	//set parameter
	function setParam($paramName, $paramValue){
		return $this->_params->set($paramName, $paramValue);
	}
	
	//get parent id
	function getParentId ($level) {
		if (!$level || (count($this->open) < $level)) return 1;
		return $this->open[count($this->open)-$level];
	}
	
	//Load Module by id or position
	function loadModule($mod)
	{
		$app		= JFactory::getApplication();
		$user		= JFactory::getUser();
		$groups		= implode(',', $user->getAuthorisedViewLevels());
		$lang 		= JFactory::getLanguage()->getTag();
		$clientId 	= (int) $app->getClientId();
		
		$db	= JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('id, title, module, position, content, showtitle, params');
		$query->from('#__modules AS m');
		$query->where('m.published = 1');
		if (is_numeric($mod)) {
			$query->where('m.id = ' . $mod);
		} else {
			$query->where('m.position = "' . $mod . '"');
		}

		$date = JFactory::getDate();
		$now = $date->toSql();
		$nullDate = $db->getNullDate();
		$query->where('(m.publish_up = '.$db->Quote($nullDate).' OR m.publish_up <= '.$db->Quote($now).')');
		$query->where('(m.publish_down = '.$db->Quote($nullDate).' OR m.publish_down >= '.$db->Quote($now).')');

		$query->where('m.access IN ('.$groups.')');
		$query->where('m.client_id = '. $clientId);
		
		// Filter by language
		if ($app->isSite() && $app->getLanguageFilter()) {
			$query->where('m.language IN (' . $db->Quote($lang) . ',' . $db->Quote('*') . ')');
		}

		$query->order('position, ordering');

		// Set the query
		$db->setQuery($query);

		$modules = $db->loadObjectList();
		
		if (!$modules) return null;
		
		$options = array('style' => 'ju_menu');
		$output = '';
		ob_start();
		foreach ($modules as $module) {
			$file				= $module->module;
			$custom				= substr($file, 0, 4) == 'mod_' ?  0 : 1;
			$module->user		= $custom;
			$module->name		= $custom ? $module->title : substr($file, 4);
			$module->style		= null;
			$module->position	= strtolower($module->position);
			$clean[$module->id]	= $module;		
			echo JModuleHelper::renderModule($module, $options);
		}
		$output = ob_get_clean();
		return $output;		
	}
}